<?xml version="1.0" encoding="euc-jp"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="html" encoding="euc-jp"/>

  <xsl:template match="/dtd">
    <html>
      <head>
        <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP"/>
        <link rel="stylesheet" type="text/css" href="amanuensis.css"/>
      </head>
      <body>
        <p class="elementTitle">Reference</p>

        <xsl:for-each select="element|entity|section">
          <!-- <xsl:sort select="name()"/> -->
          <xsl:sort select="@name"/>

          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>#</xsl:text>
              <xsl:value-of select="@name"/>
            </xsl:attribute>

            <xsl:choose>
              <xsl:when test="name() = 'element'">
                <xsl:text>&lt;</xsl:text>
                <xsl:value-of select="@name"/>
                <xsl:text>&gt;</xsl:text>
              </xsl:when>
              <xsl:when test="name() = 'entity'">
                <xsl:value-of select="@name"/>
                <xsl:text>ѥ᡼</xsl:text>
              </xsl:when>
              <xsl:when test="name() = 'section'">
                <xsl:value-of select="@name"/>
              </xsl:when>
            </xsl:choose>
          </xsl:element>

          <xsl:text> </xsl:text>
        </xsl:for-each>

        <xsl:apply-templates>
          <!-- <xsl:sort select="name()"/> -->
          <xsl:sort select="@name"/>
        </xsl:apply-templates>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="/dtd/element">
    <hr/>
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
    </xsl:element>
    <p class="element"><xsl:value-of select="@name"/></p>

    <xsl:call-template name="reference"/>

    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/element/include">
    <p class="elementSection">礹</p>
    <p class="elementInclude"><xsl:apply-templates/></p>
  </xsl:template>

  <xsl:template match="/dtd/element/include/e">
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>#</xsl:text>
        <xsl:apply-templates/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template name="reference">
    <xsl:variable name="thisName" select="@name"/>
    <xsl:if test="count(/dtd/element/include[e=$thisName]|/dtd/entity/value[e=$thisName]) > 0">
      <p class="elementSection">礵</p>
      <p class="elementInclude">
        <xsl:for-each select="/dtd/element/include[e=$thisName]|/dtd/entity/value[e=$thisName]">
          <xsl:sort select="../@name"/>

          <xsl:if test="position() > 1">
            <xsl:text>, </xsl:text>
          </xsl:if>
          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>#</xsl:text>
              <xsl:value-of select="../@name"/>
            </xsl:attribute>
            <xsl:value-of select="../@name"/>
          </xsl:element>
        </xsl:for-each>
      </p>
    </xsl:if>
  </xsl:template>

  <xsl:template match="/dtd/element/attrlist/attr">
    <dt class="attribute">
      <i><xsl:value-of select="@name"/></i>
    </dt>
    <dd class="attribute">
      <tt><xsl:value-of select="@type"/></tt>
      <xsl:text> </xsl:text>
      <xsl:choose>
        <xsl:when test="@optional = 'IMPLIED'">
          <xsl:text>άǽ</xsl:text>
        </xsl:when>
        <xsl:when test="@optional = 'REQUIRED'">
          <xsl:text>ɬ</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@optional"/> 
        </xsl:otherwise>
      </xsl:choose>
      <xsl:text> </xsl:text>
      <xsl:choose>
        <xsl:when test="@option = 'NS'">
          <xsl:text></xsl:text>
          <a href="#̻">̻</a>
          <xsl:text>, </xsl:text>
          <a href="#̾Ÿ">̾Ÿ</a>
          <xsl:text>/</xsl:text>
          <a href="#@Ÿ">@Ÿ</a>
          <xsl:text></xsl:text>
        </xsl:when>
        <xsl:when test="@option = 'AT'">
          <xsl:text></xsl:text>
          <a href="#@Ÿ">@Ÿ</a>
          <xsl:text></xsl:text>
        </xsl:when>
        <xsl:when test="@option = 'ID'">
          <xsl:text></xsl:text>
          <a href="#̻">̻</a>
          <xsl:text></xsl:text>
        </xsl:when>
        <!--
        <xsl:otherwise>
          <xsl:value-of select="@option"/> 
        </xsl:otherwise>
        -->
      </xsl:choose>
    </dd>
    <dd>
      <xsl:apply-templates/>
    </dd>
  </xsl:template>

  <xsl:template match="/dtd/element/attrlist">
    <p class="elementSection">°</p>
    <dl class="attribute">
      <xsl:apply-templates/>
    </dl>
  </xsl:template>

  <xsl:template match="/dtd/element/desc">
    <p class="elementSection"></p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/entity">
    <hr/>
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
    </xsl:element>
    <p class="element"><xsl:value-of select="@name"/>ѥ᡼</p>

    <xsl:call-template name="reference"/>

    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/entity/value">
    <p class="elementSection">Ÿ</p>
    <p class="elementInclude"><xsl:apply-templates/></p>
  </xsl:template>

  <xsl:template match="/dtd/entity/value/e">
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>#</xsl:text>
        <xsl:apply-templates/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="/dtd/entity/desc">
    <p class="elementSection"></p>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/section">
    <hr/>
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
    </xsl:element>
    <p class="element"><xsl:value-of select="@name"/></p>

    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="/dtd/section/desc">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="a">
    <xsl:element name="a">
      <xsl:attribute name="name">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
      <xsl:attribute name="href">
        <xsl:value-of select="@href"/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="//desc//e">
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>#</xsl:text>
        <xsl:apply-templates/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="p">
    <xsl:element name="p"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="i">
    <xsl:element name="i"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="b">
    <xsl:element name="b"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="tt">
    <xsl:element name="tt"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="ul">
    <xsl:element name="ul"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="li">
    <xsl:element name="li"><xsl:apply-templates/></xsl:element>
  </xsl:template>

  <xsl:template match="h">
    <xsl:element name="p">
      <xsl:attribute name="class">
        <xsl:text>elementSection</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="optionlist">
    <xsl:variable name="pattern" select="@value"/>
    <xsl:element name="ul">
      <xsl:for-each select="/dtd/element[attrlist/attr/@option=$pattern]">
        <xsl:sort select="@name"/>

        <xsl:element name="li">
          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>#</xsl:text>
              <xsl:value-of select="@name"/>
            </xsl:attribute>
            <xsl:value-of select="@name"/>
          </xsl:element>
          <xsl:text>Ǥ</xsl:text>
          
          <xsl:for-each select="attrlist/attr[@option=$pattern]">
            <xsl:if test="position() > 1">
              <xsl:text>/</xsl:text>
            </xsl:if>
            <xsl:value-of select="@name"/>
          </xsl:for-each>

          <xsl:text>°</xsl:text>
        </xsl:element>
      </xsl:for-each>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
