package com.maroontress.sanctuary;

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.regex.Matcher;
import org.w3c.dom.Element;

/**
   饹ޤϥ󥿥եǤ

   class/interface/xclassǤδ쥯饹Ǥ
*/
public abstract class Group {

    /** descǤ */
    private Description desc;

    /** ҥΡɥե륿 */
    private ChildrenFilter childrenFilter;

    /** Υ롼פ֤̾ΰ */
    private Location location;

    /** Υ롼פ˽°뼱̻ҤΥޥå */
    private HashSet<String> names;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /** Υ롼פΥե̾ */
    private String sourceFile;

    /**
       롼פޤ

       @param elem class/interface/xclass
       @param filename XMLΥե̾
    */
    protected Group(final Element elem, final String filename) {
	childrenFilter = new ChildrenFilter(elem);
	sourceFile = filename;

        idManager = IDManager.getInstance();
	names = new HashSet<String>();
        desc = new Description(
	    childrenFilter.getDirectChildrenByTagName("desc"));
    }

    /**
       ֤̾ΰ֤ꤷޤ

       @param location ֤̾ΰ
    */
    protected void setLocation(final Location location) {
        this.location = location;
    }

    /**
       Υ롼פλҥΡɥե륿ޤ

       @return Υ롼פλҥΡɥե륿
    */
    protected ChildrenFilter getChildrenFilter() {
        return childrenFilter;
    }

    /**
       Υ롼פΥɤϿޤ

       @param s 
    */
    public void addKeyword(final QualifiedName s) {
	idManager.addKeyword(location, s);
    }

    /**
       Υ롼פHTMLƥȤޤ

       @param s ʸ
       @return HTMLʸ
    */
    public String getHTML(final String s) {
	return idManager.getHTML(getPackageName(), s);
    }

    /**
       Υ롼פTeXƥȤޤ

       @param s ʸ
       @return TeXʸ
    */
    public String getTEX(final String s) {
	return idManager.getTEX(getPackageName(), s);
    }

    /**
       Υ롼פΥե̾ޤ

       @return Υ롼פΥե̾
    */
    public String getFilename() {
        return sourceFile;
    }

    /**
       Υ롼פ̾ޤ

       @return Υ롼פ̾
    */
    public String getName() {
	return location.getClassName();
    }

    /**
       Υ롼פΥѥå̾ޤ

       @return Υ롼פΥѥå̾
    */
    public String getPackageName() {
	return location.getPackageName();
    }

    /**
       Υ롼פ̾Ÿλ̵ͭޤ

       @return ̾Ÿλ꤬trueʤfalse
    */
    protected abstract boolean isNamespaceExpanded();

    /**
       HTMLޤ

       @return HTML
    */
    public String getBriefDescription() {
        return desc.getBriefText();
    }

    /**
       HTMLޤ

       @return HTML
    */
    public String getDescription() {
        return desc.getText();
    }

    /**
       ꤷǥ쥯ȥΥե˽񤯥饤ޤ

       @param dirName ǥ쥯ȥ̾
       @param fileName ե̾
       @return 饤
    */
    protected PrintWriter createPrintWriter(final String dirName,
					    final String fileName) {
	return Sanctuary.createPrintWriter(dirName, fileName, "UTF-8");
    }

    /**
       Υ롼פΥפޤ

       @return 
    */
    protected abstract String getType();

    /**
       Υ롼פTeXפޤ

       @return TeX
    */
    protected abstract String getTexType();

    /**
       إåեޤ
    */
    public abstract void printCode();

    /**
       HTMLΥɥȤޤ
    */
    public void printHtml() {
	String fileName = location.getPrefix() + ".html";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "UTF-8");
	printHtmlHeader(wr, getType());
	printHtml(wr);
	printHtmlFooter(wr);
	wr.close();
    }

    /**
       HTMLեΥإåϤޤ

       @param wr 饤
       @param s "class" ޤ "interface"
    */
    private void printHtmlHeader(final PrintWriter wr, final String s) {
	String contentType = "text/html; charset=utf-8";
	String title = getName() + " - " + location.getPrefix();

	wr.println(""
+ "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\""
+ " \"http://www.w3.org/TR/html4/loose.dtd\">\n"
+ "<html>\n"
+ "  <head>\n"
+ "    <meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"" + contentType + "\">\n"
+ "    <title>" + title + "</title>\n"
+ "    <link rel=\"stylesheet\" type=\"text/css\" href=\"sanctuary.css\">\n"
+ "  </head>\n"
+ "  <body>");
	printHtmlBodyHeader(wr);
	wr.println(""
+ "    <h3>package " + getPackageName() + "</h3>\n"
+ "    <h1>" + s + " " + getName() + "</h1>");
	printHtmlUsage(wr);
	wr.println(""
+ "    <dl><dd>" + getDescription() + "</dd></dl>\n"
+ "    <hr>");
    }

    /**
       HTMLեΥܥǥΥإåϤޤ

       @param wr 饤
    */
    protected abstract void printHtmlBodyHeader(final PrintWriter wr);

    /**
       HTMLեλˡϤޤ

       @param wr 饤
    */
    protected abstract void printHtmlUsage(final PrintWriter wr);

    /**
       HTMLեʸϤޤ

       @param wr 饤
    */
    protected abstract void printHtml(final PrintWriter wr);

    /**
       HTMLեΥեåϤޤ

       @param wr 饤
    */
    private void printHtmlFooter(final PrintWriter wr) {
	wr.println(""
+ "  </body>\n"
+ "</html>");
    }

    /**
       TeXեޤ
    */
    public void printTex() {
	String fileName = location.getPrefix() + ".tex";
	PrintWriter wr = Sanctuary.createPrintWriter(null, fileName, "EUC-JP");
	String ns = getPackageName() + "." + getName();

	wr.println("\\S" + getTexType() + "{" + getName() + "}");
	wr.println("\\Slabel{:" + Tex.safeTarget(ns) + ":}");
	printTexUsage(wr);
	wr.print("\n" + desc.getTexText() + "\n");
	printTex(wr);
	wr.close();
    }

    /**
       TeXեλˡϤޤ

       @param wr 饤
    */
    protected abstract void printTexUsage(PrintWriter wr);

    /**
       TeXեʸϤޤ

       @param wr 饤
    */
    protected abstract void printTex(PrintWriter wr);

    /**
       ֤Υեޤ
    */
    public abstract void printStub();

    /**
       ݡȥޥϤޤ

       @param wr 饤
    */
    public void printImportMacro(final PrintWriter wr) {
	String qualifiedPrefix = location.getPrefix();
	String simplePrefix = location.getSimplePrefix();
	String[] sortedNames = names.toArray(new String[0]);
	Arrays.sort(sortedNames);
	for (String s : sortedNames) {
	    String qualifiedName = prependPrefix(qualifiedPrefix, s);
	    String simpleName = prependPrefix(simplePrefix, s);
	    wr.println("#define " + simpleName + " " + qualifiedName);
	}
    }

    /**
       ʸ˥ץեå֤ޤ

       @param prefix ץեå
       @param s ʸ
       @return ץեå֤ʸ
    */
    protected abstract String prependPrefix(final String prefix,
					    final String s);

    /**
       Υ롼פ˥ݡͥȤɲäޤ

       @param compound ѥ
       @param type struct/union/enum
    */
    public abstract void addCompound(final Compound compound,
				     final String type);

    /**
       ʸ˴ޤޤ봰ʥ饹̾unionŸޤ

       @param s ʸ
       @return Ÿʸ
    */
    private String unionize(final String s) {
        String in = s;
        String out = "";

        while (in.length() > 0) {
            Matcher m = FQCN.RE_PATTERN.matcher(in);
            if (!m.find()) {
                out += in;
                break;
            }
            int start = m.start();
            int end = m.end();
            String fqcn = in.substring(start, end);
            out += in.substring(0, start) + "union " + fqcn.replace('.', '_');
            importXClass(fqcn);
            in = in.substring(end);
        }
        return out;
    }

    /**
       ʸ@Ÿޤ

       ǽʸ˴ޤޤ@פץեåŸޤ

       ʸ˴ޤޤ봰ʥ饹̾unionŸޤ
       㤨Сfoo.bar.Bazפϡunion foo_bar_BazפŸޤ

       CΥȤŸޤ
       CΥȤĤƤʤnull֤ޤ

       @param s ʸ
       @param prefix ץեå
       @return Ÿʸ
    */
    private String expandATString(final String s, final String prefix) {
	String z;

	try {
	    z = CommentedString.replaceAll(s, new CommentedString.Replacer() {
		public String replace(final String s) {
		    return s.replace("@", prefix);
		}
	    });
	} catch (UnterminatedCommentException e) {
	    return null;
	}
	return unionize(z);
    }

    /**
       Ǥ°ͤ@Ÿ̤ޤ

       @param elem 
       @param attrName °̾
       @return @Ÿ°
    */
    public String expandAT(final Element elem, final String attrName) {
	String s;

	s = elem.getAttribute(attrName);
	if (s.equals("")) {
	    String m = "empty value: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	if ((s = expandATString(s, location.getPrefix())) == null) {
	    String m = "unterminated comment: " + attrName;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return s;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       ̾Ÿλ꤬: ̻Ҥ@פξϤ̾
       ɽץեåŸޤʳξ硢ץեå
        + "_" + ̻Ҥ֤ޤisImportedtrueξϡŸ
       ̻Ҥ򥤥ݡȥޥȤϿޤ

       ̾Ÿλ꤬ʤ: @Ÿη̤֤ޤ

       @param elem 
       @param attrName °̾
       @param isImported ݡȥޥϿtrue
       @return ̾Ÿޤ@Ÿ°
    */
    public QualifiedName expandNS(final Element elem, final String attrName,
				  final boolean isImported) {
	QualifiedName t;
	if (!isNamespaceExpanded()) {
	    t = QualifiedName.intern(expandAT(elem, attrName));
	} else {
	    String s = elem.getAttribute(attrName);
	    if (s.equals("")) {
		String m = "empty value: " + attrName;
		throw new NodeException(elem.getAttributeNode(attrName), m);
	    }
	    if (isImported) {
		names.add(s);
	    }
	    String s1 = prependPrefix(location.getPrefix(), s);
	    String s2 = prependPrefix(location.getSimplePrefix(), s);
	    t = QualifiedName.intern(s1, s2);
	}
	if (!idManager.isCID(t.getQualified())) {
	    String m = "invalid identifier: " + t;
	    throw new NodeException(elem.getAttributeNode(attrName), m);
	}
	return t;
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       expandNS(elem, attrName, true)Ʊ̣Ǥ

       @param elem 
       @param attrName °̾
       @return ̾Ÿޤ@Ÿ°
    */
    public QualifiedName expandNS(final Element elem, final String attrName) {
	return expandNS(elem, attrName, true);
    }

    /**
       Ǥ°ͤ򤳤Υ롼פ֤̾Ÿޤ

       °ꤵƤʤжʸ֤ޤǤʤС
       expandNS(elem, attrName)Ʊ̣Ǥ

       @param elem 
       @param attrName °̾
       @return °ꤵƤʤжʸ󡢤Ǥʤ̾
       Ÿޤ@Ÿ°
    */
    public QualifiedName expandImpliedNS(final Element elem,
					 final String attrName) {
	if (elem.getAttributeNode(attrName) == null) {
	    return QualifiedName.intern("");
	}
	return expandNS(elem, attrName);
    }

    /**
       ʸ˴ޤޤƤ륿̾򥤥ݡȤ륿ȤϿޤ

       @param s ʸ
    */
    public abstract void importTags(final String s);

    /**
       ݡȤ륿Ͽޤ

       @param type struct|union|enum
       @param tag ̾
    */
    public abstract void importTag(final String type, final String tag);

    /**
       ʥ饹̾򥤥ݡȤޤ

       @param s ʥ饹̾
    */
    protected abstract void importXClass(final String s);
}
