package com.maroontress.sanctuary;

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ݡȤ줿νǤ
*/
public class ImportedTags {

    /** ¤ΡΤΥɽ */
    private static final String RE_TAG
        = "(struct|union) +[_A-Za-z]\\w*";

    /** ¤ΡΡ󷿤Υɽ */
    private static final String RE_TAG_GCC
        = "(struct|union|enum) +[_A-Za-z]\\w*";

    /** ¤ΡΤΥɽΥѥѤߥѥ */
    private static Pattern tagPattern;

    /** ¤ΡΤΥɽΥѥѤߥѥ */
    private static Pattern tagGccPattern;

    /** ݡȤ륿Υꥹ */
    private HashSet<String> tags;

    static {
	tagPattern = Pattern.compile(RE_TAG);
	tagGccPattern = Pattern.compile(RE_TAG_GCC);
    }

    /**
       ݡȤ줿νޤ
    */
    public ImportedTags() {
	tags = new HashSet<String>();
    }

    /**
       ݡȤ륿ɲäޤ

       @param s ʸ "(struct|union|enum) + (̾)"
       @return ɲäݡȤǤtrueˤfalse
    */
    private boolean addTag(final String s) {
	int k = s.indexOf(' ');
	String type = s.substring(0, k).trim();
	String tag = s.substring(k).trim();
	return tags.add(type + " " + tag);
    }

    /**
       ݡȤ륿Ͽޤ

       @param type struct|union|enum
       @param tag ̾
    */
    public void add(final String type, final String tag) {
	tags.add(type + " " + tag);
    }

    /**
       ʸ˴ޤޤƤ륿̾򥤥ݡȤ륿ȤϿޤ

       @param s ʸ
    */
    public void add(final String s) {
	String in = CommentedString.deleteComments(s);
	while (in.length() > 0) {
	    Matcher m = tagPattern.matcher(in);
	    if (!m.find()) {
		return;
	    }
	    int start = m.start();
	    int end = m.end();
	    String tag = in.substring(start, end);
	    addTag(tag);
	    in = in.substring(end);
	}
    }

    /**
       importǤ򥤥ݡȤ륿ȤϿޤ

       @param g 롼
       @param nodes importǤΥΡɥꥹ
    */
    public void addNodeList(final Group g, final NodeList nodes) {
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    String type = elem.getAttribute("type");
	    String tag = g.expandAT(elem, "tag");
	    String s = type + " " + tag;
	    if (!addTag(s)) {
		System.err.println(
		    g.getFilename() + ": warning: redundant import: " + s);
	    }
	}
    }

    /**
       إåե˥ݡȤ륿Ϥޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (tags.size() == 0) {
	    return;
	}
	wr.println("");
	String[] a = tags.toArray(new String[0]);
	Arrays.sort(a);
	for (String s : a) {
	    wr.println(s + ";");
	}
    }
}
