package com.maroontress.sanctuary;

import java.util.HashMap;

/**
   TeXϤΤΥ桼ƥƥǤ
*/
public final class Tex {

    /** פʸȥ׸ʸΥޥå */
    private static HashMap<Character, String> map;

    /** إ⡼ɤǥפʸȥ׸ʸΥޥå */
    private static HashMap<Character, String> mathMap;

    static {
	map = new HashMap<Character, String>();
	map.put('>', "\\textgreater ");
	map.put('<', "\\textless ");
	map.put('|', "\\textbar ");
	map.put('\\', "\\textbackslash ");
	map.put('^', "\\textasciicircum ");
	map.put('~', "\\textasciitilde ");
	map.put('{', "\\{");
	map.put('}', "\\}");
	map.put('%', "\\%");
	map.put('&', "\\&");
	map.put('#', "\\#");
        map.put('$', "\\$");
	map.put('_', "\\-\\_\\-");

	mathMap = new HashMap<Character, String>();
	mathMap.put('\\', "\\mbox{\\textbackslash}");
	mathMap.put('^', "\\mbox{\\textasciicircum}");
	mathMap.put('~', "\\mbox{\\textasciitilde}");
	mathMap.put('{', "\\{");
	mathMap.put('}', "\\}");
	mathMap.put('%', "\\%");
	mathMap.put('&', "\\&");
	mathMap.put('#', "\\#");
        mathMap.put('$', "\\$");
        mathMap.put('_', "\\_");
    }
    /**
       󥹥ȥ饯Ǥ
    */
    private Tex() {
    }

    /**
       TeXǽϤǤ褦˥פʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safe(final String s) {
	String t = "";
	int n = s.length();
	boolean isLastLowerCase = false;
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    String m = map.get(c);
	    if (m != null) {
		t += m;
	    } else if (Character.isUpperCase(c) && isLastLowerCase) {
		t += "\\-" + c;
	    } else {
		t += c;
	    }
	    isLastLowerCase = Character.isLowerCase(c);
	}
	return t;
    }

    /**
       TeXοɽʸޤ

       @param s ʸ
       @return ɽʸ
    */
    public static String math(final String s) {
	String t = "";
	int n = s.length();
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    String m = mathMap.get(c);
	    if (m != null) {
		t += m;
	    } else {
		t += c;
	    }
	}
	return "$" + t + "$";
    }

    /**
       hyperrefѥåhrefޥΰ˻ꤹ뤿˥
       ʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safeURL(final String s) {
	String t = "";
	int n = s.length();
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    switch (c) {
	    case '%':
	    case '_':
	    case '#':
		t += "\\" + c;
		break;
	    default:
		t += c;
		break;
	    }
	}
	return t;
    }

    /**
       hyperrefѥåhypertargetޥΰ˻ꤹ뤿˥
       פʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safeTarget(final String s) {
	String t = "";
	int n = s.length();
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    if ((c >= '0' && c <= '9')
		|| (c >= 'A' && c <= 'Z')
		|| (c >= 'a' && c <= 'z')) {
		t += c;
	    } else {
		t += "[" + (int) c + "]";
	    }
	}
	return t;
    }
}
